<template>
  <div>
    <div class="dashboard__header">
      <h1 class="dashboard__title">ویرایش آدرس</h1>
      <div class="dashboard__actions">
        <Button type="text" color='dark' light round size="sm" @click.native="$router.push('/dashboard/addresses')">
          <template #icon>
            <BackIcon />
          </template>
        </Button>
      </div>
    </div>
    <div class="dashboard__body">
      <DashboardNavigation class="dashboard__nav" active="addresses"/>
      <div class="dashboard__content">
        <Card title="اطلاعات آدرس">
          <AddressForm class="address-form" :address="address" :states="states" :stateCities="cities" />
        </Card>
      </div>
    </div>
  </div>
</template>

<script>
import BackIcon from "@/assets/svgs/back.svg";
import Button from "@/components/base/Button";
import Card from "@/components/base/Card";
import AddressForm from "@/components/dashboard/AddressForm";
import DashboardNavigation from "@/components/layout/DashboardNavigation";

export default {
  components: {
    BackIcon,
    Button,
    Card,
    AddressForm,
    DashboardNavigation
  },
  layout: 'dashboard',
  head() {
    return {
      title: "ویرایش آدرس"
    }
  },
  async asyncData(context) {
    let states = [];
    const token = context.store.getters['auth/getToken'];
    const id = context.route.params.id;
    let address = {};
    let cities = [];
    await context.store.dispatch('addresses/fetchStates').then(response => {
      if (response.status === 200) {
        states = response.data.data;
      }
    }).catch(error => {
      console.log(error);
    });
    await context.store.dispatch('addresses/fetchAddress', { id, token }).then(response => {
      if (response.status === 200) {
        address = response.data.data;
      }
    }).catch(error => {
      console.log(error);
    });
    const stateId = states.find(cur => cur.title === address.state).id;
    await context.store.dispatch('addresses/fetchState', stateId).then(response => {
      if (response.status === 200) {
        cities = response.data.data.cities;
      }
    }).catch(error => {
      console.log(error);
    });
    return {
      states,
      cities,
      address
    }
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.address-form
  padding $sm 0
</style>